/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   RealLtc2600.cpp
 * Author: C. Defrance
 * 
 * Created on 8 mars 2017, 17:26
 */
#include <stdio.h>

#include <cstring>

#include "RealLtc2600.h"

RealLtc2600::RealLtc2600() {
    bcm2835_init();
    if( bcm2835_spi_begin() == 0) {
        printf("\nL'initialisation de la SPI a échouée. Avez-vous pensé à exécuter le programme avec `sudo` ?\n");
        exit(-1);
    } else {
        bcm2835_spi_chipSelect(CS_LD);
        bcm2835_spi_setChipSelectPolarity(CS_LD, LOW);
        bcm2835_spi_setDataMode(BCM2835_SPI_MODE0); // CPOL=0 => SCLK à 0 à l'état repos, CPHA=0 => donnée transmise au 1ier front d'horloge
                                                // !! A CONFIRMER AUPRES DE CHRISTIAN !!
    }
}

RealLtc2600::RealLtc2600(const RealLtc2600& orig) {
}

RealLtc2600::~RealLtc2600() {
    bcm2835_spi_end();
    bcm2835_close();
}

int RealLtc2600::sendFrame(uint8_t * theData) {
    char rData[ 3 ];
    
    bcm2835_spi_transfernb(reinterpret_cast<char *>(theData), rData, 3);
    
    //printf("datas reçues : 0x%02x - 0x%02x - 0x%02x\n", rData[0], rData[1], rData[2]);
    
    return  memcmp(theData, rData, 3) == 0 ? 0 : -1;
}
